diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/eht/tid-to-link-mapping-element.h ns-3.38/src/wifi/model/eht/tid-to-link-mapping-element.h
--- ns-3.37/src/wifi/model/eht/tid-to-link-mapping-element.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/src/wifi/model/eht/tid-to-link-mapping-element.h	2023-03-16 20:54:23.856869200 -0700
@@ -0,0 +1,126 @@
+/*
+ * Copyright (c) 2022
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Sharan Naribole <sharan.naribole@gmail.com>
+ */
+
+#ifndef TID_TO_LINK_MAPPING_H
+#define TID_TO_LINK_MAPPING_H
+
+#include <ns3/wifi-information-element.h>
+
+#include <list>
+#include <map>
+#include <optional>
+#include <vector>
+
+namespace ns3
+{
+
+/**
+ * TID-to-Link Mapping Control Direction
+ * IEEE 802.11be D2.0 Figure 9-1002an
+ */
+enum class TidLinkMapDir : uint8_t
+{
+    DOWNLINK = 0,
+    UPLINK = 1,
+    BOTH_DIRECTIONS = 2,
+};
+
+/// whether to enforce the default link mapping
+constexpr auto DEFAULT_WIFI_TID_LINK_MAPPING{true};
+/// default value for the Direction subfield of the TID-To-Link Control field
+constexpr auto DEFAULT_WIFI_TID_LINK_MAP_DIR{TidLinkMapDir::BOTH_DIRECTIONS};
+/// size in bytes of the Link Mapping Of TID n field (IEEE 802.11be D2.0 9.4.2.314)
+constexpr uint16_t WIFI_LINK_MAPPING_PER_TID_SIZE_B = 2;
+/// size in bytes of the TID-To-Link Control field with default link mapping
+constexpr uint16_t WIFI_TID_TO_LINK_MAPPING_CONTROL_BASIC_SIZE_B =
+    1; // IEEE 802.11be D2.0 9.4.2.314
+/// size in bytes of the Link Mapping Presence Indicator field (IEEE 802.11be D2.0 9.4.2.314)
+constexpr uint16_t WIFI_LINK_MAPPING_PRESENCE_IND_SIZE_B = 1;
+
+/**
+ * \brief TID-to-Link Mapping Information Element
+ * \ingroup wifi
+ *
+ * This class serializes and deserializes
+ * the TID-to-Link Mapping element
+ * IEEE 802.11be D2.0 9.4.2.314
+ *
+ */
+class TidToLinkMapping : public WifiInformationElement
+{
+  public:
+    /**
+     * TID-to-Link Mapping Control subfield
+     * IEEE 802.11be D2.0 Figure 9-1002an
+     */
+    struct Control
+    {
+        TidLinkMapDir direction{DEFAULT_WIFI_TID_LINK_MAP_DIR}; ///< Direction
+        bool defaultMapping{DEFAULT_WIFI_TID_LINK_MAPPING};     ///< Default link mapping
+        std::optional<uint8_t> presenceBitmap;                  ///< Link Mapping Presence Indicator
+
+        /// \return Serialized size of TID-to-Link Mapping Control in octets
+        uint16_t GetSubfieldSize() const;
+
+        /**
+         * Serialize the TID-to-Link Mapping Control subfield
+         *
+         * \param start iterator pointing to where the subfield should be written to
+         */
+        void Serialize(Buffer::Iterator& start) const;
+        /**
+         * Deserialize the TID-to-Link Mapping Control subfield
+         *
+         * \param start iterator pointing to where the subfield should be read from
+         * \return the number of octets read
+         */
+        uint16_t Deserialize(Buffer::Iterator start);
+    };
+
+    WifiInformationElementId ElementId() const override;
+    WifiInformationElementId ElementIdExt() const override;
+
+    /**
+     * Set the Link Mapping field of the given TID such that the given TID is mapped
+     * to the links associated with the given link IDs.
+     *
+     * \param tid the given TID
+     * \param linkIds the IDs of the links which the given TID is mapped to
+     */
+    void SetLinkMappingOfTid(uint8_t tid, std::list<uint8_t> linkIds);
+    /**
+     * Get the Link Mapping field of the given TID.
+     *
+     * \param tid the given TID
+     * \return the IDs of the links which the given TID is mapped to
+     */
+    std::list<uint8_t> GetLinkMappingOfTid(uint8_t tid) const;
+
+    TidToLinkMapping::Control m_control;       ///< TID-to-link Mapping Control
+    std::map<uint8_t, uint16_t> m_linkMapping; ///< TID-indexed Link Mapping
+
+  private:
+    uint16_t GetInformationFieldSize() const override;
+    void SerializeInformationField(Buffer::Iterator start) const override;
+    uint16_t DeserializeInformationField(Buffer::Iterator start, uint16_t length) override;
+};
+
+} // namespace ns3
+
+#endif /* TID_TO_LINK_MAPPING_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/fcfs-wifi-queue-scheduler.cc ns-3.38/src/wifi/model/fcfs-wifi-queue-scheduler.cc
--- ns-3.37/src/wifi/model/fcfs-wifi-queue-scheduler.cc	2022-11-01 17:37:24.743395800 -0700
+++ ns-3.38/src/wifi/model/fcfs-wifi-queue-scheduler.cc	2023-03-16 20:54:23.856869200 -0700
@@ -29,6 +29,38 @@
 
 NS_LOG_COMPONENT_DEFINE("FcfsWifiQueueScheduler");
 
+bool
+operator==(const FcfsPrio& lhs, const FcfsPrio& rhs)
+{
+    return lhs.priority == rhs.priority && lhs.type == rhs.type;
+}
+
+bool
+operator<(const FcfsPrio& lhs, const FcfsPrio& rhs)
+{
+    // Control queues have the highest priority
+    if (lhs.type == WIFI_CTL_QUEUE && rhs.type != WIFI_CTL_QUEUE)
+    {
+        return true;
+    }
+    if (lhs.type != WIFI_CTL_QUEUE && rhs.type == WIFI_CTL_QUEUE)
+    {
+        return false;
+    }
+    // Management queues have the second highest priority
+    if (lhs.type == WIFI_MGT_QUEUE && rhs.type != WIFI_MGT_QUEUE)
+    {
+        return true;
+    }
+    if (lhs.type != WIFI_MGT_QUEUE && rhs.type == WIFI_MGT_QUEUE)
+    {
+        return false;
+    }
+    // we get here if both priority values refer to container queues of the same type,
+    // hence we can compare the time values.
+    return lhs.priority < rhs.priority;
+}
+
 NS_OBJECT_ENSURE_REGISTERED(FcfsWifiQueueScheduler);
 
 TypeId
@@ -65,23 +97,31 @@
         return nullptr;
     }
 
-    // Management frames should be prioritized
-    if (m_dropPolicy == DROP_OLDEST || mpdu->GetHeader().IsMgt())
+    // Control and management frames should be prioritized
+    if (m_dropPolicy == DROP_OLDEST || mpdu->GetHeader().IsCtl() || mpdu->GetHeader().IsMgt())
     {
-        auto sortedQueuesIt = GetSortedQueues(ac).begin();
-
-        while (sortedQueuesIt != GetSortedQueues(ac).end() &&
-               std::get<WifiContainerQueueType>(sortedQueuesIt->second.get().first) ==
-                   WIFI_MGT_QUEUE)
-        {
-            sortedQueuesIt++;
-        }
-
-        if (sortedQueuesIt != GetSortedQueues(ac).end())
+        for (const auto& [priority, queueInfo] : GetSortedQueues(ac))
         {
-            return queue->PeekByQueueId(sortedQueuesIt->second.get().first);
+            if (std::get<WifiContainerQueueType>(queueInfo.get().first) == WIFI_MGT_QUEUE ||
+                std::get<WifiContainerQueueType>(queueInfo.get().first) == WIFI_CTL_QUEUE)
+            {
+                // do not drop control or management frames
+                continue;
+            }
+
+            // do not drop frames that are inflight or to be retransmitted
+            Ptr<WifiMpdu> item;
+            while ((item = queue->PeekByQueueId(queueInfo.get().first, item)))
+            {
+                if (!item->IsInFlight() && !item->GetHeader().IsRetry())
+                {
+                    NS_LOG_DEBUG("Dropping " << *item);
+                    return item;
+                }
+            }
         }
     }
+    NS_LOG_DEBUG("Dropping received MPDU: " << *mpdu);
     return mpdu;
 }
 
@@ -100,10 +140,7 @@
         return;
     }
 
-    auto priority =
-        (mpdu->GetHeader().IsMgt() ? Seconds(0) // Highest priority for management frames
-                                   : mpdu->GetExpiryTime());
-    SetPriority(ac, queueId, priority);
+    SetPriority(ac, queueId, {mpdu->GetExpiryTime(), std::get<WifiContainerQueueType>(queueId)});
 }
 
 void
@@ -120,15 +157,11 @@
 
     for (const auto& queueId : queueIds)
     {
-        if (std::get<WifiContainerQueueType>(queueId) == WIFI_MGT_QUEUE)
+        if (auto item = GetWifiMacQueue(ac)->PeekByQueueId(queueId))
         {
-            // the priority of management queues does not change
-            continue;
-        }
-
-        if (auto item = GetWifiMacQueue(ac)->PeekByQueueId(queueId); item != nullptr)
-        {
-            SetPriority(ac, queueId, item->GetExpiryTime());
+            SetPriority(ac,
+                        queueId,
+                        {item->GetExpiryTime(), std::get<WifiContainerQueueType>(queueId)});
         }
     }
 }
@@ -147,15 +180,11 @@
 
     for (const auto& queueId : queueIds)
     {
-        if (std::get<0>(queueId) == WIFI_MGT_QUEUE)
-        {
-            // the priority of management queues does not change
-            continue;
-        }
-
-        if (auto item = GetWifiMacQueue(ac)->PeekByQueueId(queueId); item != nullptr)
+        if (auto item = GetWifiMacQueue(ac)->PeekByQueueId(queueId))
         {
-            SetPriority(ac, queueId, item->GetExpiryTime());
+            SetPriority(ac,
+                        queueId,
+                        {item->GetExpiryTime(), std::get<WifiContainerQueueType>(queueId)});
         }
     }
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/fcfs-wifi-queue-scheduler.h ns-3.38/src/wifi/model/fcfs-wifi-queue-scheduler.h
--- ns-3.37/src/wifi/model/fcfs-wifi-queue-scheduler.h	2022-11-01 17:37:24.743395800 -0700
+++ ns-3.38/src/wifi/model/fcfs-wifi-queue-scheduler.h	2023-03-16 20:54:23.856869200 -0700
@@ -32,11 +32,36 @@
 /**
  * \ingroup wifi
  *
+ * Definition of priority for container queues.
+ */
+struct FcfsPrio
+{
+    Time priority;               ///< time priority
+    WifiContainerQueueType type; ///< type of container queue
+};
+
+/**
+ * \param lhs the left hand side priority
+ * \param rhs the right hand side priority
+ * \return whether the left hand side priority is equal to the right hand side priority
+ */
+bool operator==(const FcfsPrio& lhs, const FcfsPrio& rhs);
+/**
+ * \param lhs the left hand side priority
+ * \param rhs the right hand side priority
+ * \return whether the left hand side priority is less than the right hand side priority
+ */
+bool operator<(const FcfsPrio& lhs, const FcfsPrio& rhs);
+
+/**
+ * \ingroup wifi
+ *
  * FcfsWifiQueueScheduler is a wifi queue scheduler that serves data frames in a
- * first come first serve fashion. Management frames have higher priority than data
- * frames, hence the former will be served before the latter.
+ * first come first serve fashion. Control frames have the highest priority.
+ * Management frames have the second highest priority. Hence, data frames are
+ * served after control and management frames.
  */
-class FcfsWifiQueueScheduler : public WifiMacQueueSchedulerImpl<Time>
+class FcfsWifiQueueScheduler : public WifiMacQueueSchedulerImpl<FcfsPrio>
 {
   public:
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/frame-exchange-manager.cc ns-3.38/src/wifi/model/frame-exchange-manager.cc
--- ns-3.37/src/wifi/model/frame-exchange-manager.cc	2022-11-01 17:37:24.743395800 -0700
+++ ns-3.38/src/wifi/model/frame-exchange-manager.cc	2023-03-16 20:54:23.856869200 -0700
@@ -95,13 +95,7 @@
     m_channelAccessManager = nullptr;
     m_protectionManager = nullptr;
     m_ackManager = nullptr;
-    if (m_phy)
-    {
-        m_phy->TraceDisconnectWithoutContext(
-            "PhyRxPayloadBegin",
-            MakeCallback(&FrameExchangeManager::RxStartIndication, this));
-    }
-    m_phy = nullptr;
+    ResetPhy();
     Object::DoDispose();
 }
 
@@ -191,11 +185,14 @@
         m_phy->TraceDisconnectWithoutContext(
             "PhyRxPayloadBegin",
             MakeCallback(&FrameExchangeManager::RxStartIndication, this));
-        m_phy->SetReceiveOkCallback(MakeNullCallback<void,
-                                                     Ptr<const WifiPsdu>,
-                                                     RxSignalInfo,
-                                                     WifiTxVector,
-                                                     std::vector<bool>>());
+        if (m_phy->GetState())
+        {
+            m_phy->SetReceiveOkCallback(MakeNullCallback<void,
+                                                         Ptr<const WifiPsdu>,
+                                                         RxSignalInfo,
+                                                         WifiTxVector,
+                                                         std::vector<bool>>());
+        }
         m_phy = nullptr;
     }
 }
@@ -335,7 +332,7 @@
     if (!mpdu->IsFragment() && !mpdu->GetHeader().IsRetry())
     {
         uint16_t sequence = m_txMiddle->GetNextSequenceNumberFor(&mpdu->GetHeader());
-        mpdu->GetHeader().SetSequenceNumber(sequence);
+        mpdu->AssignSeqNo(sequence);
     }
 
     NS_LOG_DEBUG("MPDU payload size=" << mpdu->GetPacketSize()
@@ -412,6 +409,11 @@
     // Set QoS Ack policy if this is a QoS data frame
     WifiAckManager::SetQosAckPolicy(m_mpdu, m_txParams.m_acknowledgment.get());
 
+    if (m_mpdu->IsQueued())
+    {
+        m_mpdu->SetInFlight(m_linkId);
+    }
+
     switch (m_txParams.m_protection->method)
     {
     case WifiProtection::RTS_CTS:
@@ -426,6 +428,12 @@
     default:
         NS_ABORT_MSG("Unknown protection type");
     }
+
+    if (m_txParams.m_acknowledgment->method == WifiAcknowledgment::NONE)
+    {
+        // we are done with frames that do not require acknowledgment
+        m_mpdu = nullptr;
+    }
 }
 
 void
@@ -484,12 +492,6 @@
 
     // transmit the MPDU
     ForwardMpduDown(m_mpdu, m_txParams.m_txVector);
-
-    if (m_txParams.m_acknowledgment->method == WifiAcknowledgment::NONE)
-    {
-        // we are done with frames that do not require acknowledgment
-        m_mpdu = nullptr;
-    }
 }
 
 void
@@ -877,6 +879,11 @@
     else
     {
         NS_LOG_DEBUG("Missed Ack, retransmit MPDU");
+        if (mpdu->IsQueued()) // the MPDU may have been removed due to lifetime expiration
+        {
+            mpdu = m_mac->GetTxopQueue(mpdu->GetQueueAc())->GetOriginal(mpdu);
+            mpdu->ResetInFlight(m_linkId);
+        }
         mpdu->GetHeader().SetRetry();
         RetransmitMpduAfterMissedAck(mpdu);
         m_dcf->UpdateFailedCw(m_linkId);
@@ -906,6 +913,14 @@
 {
     NS_LOG_FUNCTION(this << *psdu);
 
+    for (const auto& mpdu : *PeekPointer(psdu))
+    {
+        if (mpdu->IsQueued())
+        {
+            mpdu->ResetInFlight(m_linkId);
+        }
+    }
+
     GetWifiRemoteStationManager()->ReportRtsFailed(psdu->GetHeader(0));
 
     if (!GetWifiRemoteStationManager()->NeedRetransmission(*psdu->begin()))
@@ -929,25 +944,27 @@
     // been transmitted, both in case the MPDUs have been discarded and in case the
     // MPDUs have to be transmitted (because a new sequence number is assigned to
     // MPDUs that have never been transmitted and are selected for transmission)
-    for (const auto& mpdu : *PeekPointer(psdu))
-    {
-        ReleaseSequenceNumber(mpdu);
-    }
+    ReleaseSequenceNumbers(psdu);
+
     TransmissionFailed();
 }
 
 void
-FrameExchangeManager::ReleaseSequenceNumber(Ptr<WifiMpdu> mpdu) const
+FrameExchangeManager::ReleaseSequenceNumbers(Ptr<const WifiPsdu> psdu) const
 {
-    NS_LOG_FUNCTION(this << *mpdu);
+    NS_LOG_FUNCTION(this << *psdu);
+
+    NS_ASSERT_MSG(psdu->GetNMpdus() == 1, "A-MPDUs should be handled by the HT FEM override");
+    auto mpdu = *psdu->begin();
 
     // the MPDU should be still in the DCF queue, unless it expired.
-    // If the MPDU has never been transmitted, it will be assigned a sequence
-    // number again the next time we try to transmit it. Therefore, we need to
+    // If the MPDU has never been transmitted and is not in-flight, it will be assigned
+    // a sequence number again the next time we try to transmit it. Therefore, we need to
     // make its sequence number available again
-    if (!mpdu->GetHeader().IsRetry())
+    if (!mpdu->GetHeader().IsRetry() && !mpdu->IsInFlight())
     {
-        m_txMiddle->SetSequenceNumberFor(&mpdu->GetHeader());
+        mpdu->UnassignSeqNo();
+        m_txMiddle->SetSequenceNumberFor(&mpdu->GetOriginal()->GetHeader());
     }
 }
 
@@ -1038,35 +1055,46 @@
         PreProcessFrame(psdu, txVector);
     }
 
-    // ignore unicast frames that are not addressed to us
     Mac48Address addr1 = psdu->GetAddr1();
-    if (!addr1.IsGroup() && addr1 != m_self)
+
+    if (addr1.IsGroup() || addr1 == m_self)
     {
-        if (m_promisc && psdu->GetNMpdus() == 1 && psdu->GetHeader(0).IsData())
+        // receive broadcast frames or frames addressed to us only
+        if (psdu->GetNMpdus() == 1)
         {
-            m_rxMiddle->Receive(*psdu->begin(), m_linkId);
+            // if perMpduStatus is not empty (i.e., this MPDU is not included in an A-MPDU)
+            // then it must contain a single value which must be true (i.e., the MPDU
+            // has been correctly received)
+            NS_ASSERT(perMpduStatus.empty() || (perMpduStatus.size() == 1 && perMpduStatus[0]));
+            // Ack and CTS do not carry Addr2
+            if (!psdu->GetHeader(0).IsAck() && !psdu->GetHeader(0).IsCts())
+            {
+                GetWifiRemoteStationManager()->ReportRxOk(psdu->GetHeader(0).GetAddr2(),
+                                                          rxSignalInfo,
+                                                          txVector);
+            }
+            ReceiveMpdu(*(psdu->begin()), rxSignalInfo, txVector, perMpduStatus.empty());
+        }
+        else
+        {
+            EndReceiveAmpdu(psdu, rxSignalInfo, txVector, perMpduStatus);
         }
-        return;
     }
-
-    if (psdu->GetNMpdus() == 1)
+    else if (m_promisc)
     {
-        // if perMpduStatus is not empty (i.e., this MPDU is not included in an A-MPDU)
-        // then it must contain a single value which must be true (i.e., the MPDU
-        // has been correctly received)
-        NS_ASSERT(perMpduStatus.empty() || (perMpduStatus.size() == 1 && perMpduStatus[0]));
-        // Ack and CTS do not carry Addr2
-        if (!psdu->GetHeader(0).IsAck() && !psdu->GetHeader(0).IsCts())
+        for (const auto& mpdu : *PeekPointer(psdu))
         {
-            GetWifiRemoteStationManager()->ReportRxOk(psdu->GetHeader(0).GetAddr2(),
-                                                      rxSignalInfo,
-                                                      txVector);
+            if (!mpdu->GetHeader().IsCtl())
+            {
+                m_rxMiddle->Receive(mpdu, m_linkId);
+            }
         }
-        ReceiveMpdu(*(psdu->begin()), rxSignalInfo, txVector, perMpduStatus.empty());
     }
-    else
+
+    if (!perMpduStatus.empty())
     {
-        EndReceiveAmpdu(psdu, rxSignalInfo, txVector, perMpduStatus);
+        // for A-MPDUs, we get here only once
+        PostProcessFrame(psdu, txVector);
     }
 }
 
@@ -1074,6 +1102,12 @@
 FrameExchangeManager::PreProcessFrame(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector)
 {
     NS_LOG_FUNCTION(this << psdu << txVector);
+}
+
+void
+FrameExchangeManager::PostProcessFrame(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector)
+{
+    NS_LOG_FUNCTION(this << psdu << txVector);
 
     UpdateNav(psdu, txVector);
 }
@@ -1083,13 +1117,8 @@
 {
     NS_LOG_FUNCTION(this << psdu << txVector);
 
-    if (psdu->GetHeader(0).GetRawDuration() > 32767)
+    if (!psdu->HasNav())
     {
-        // When the contents of a received Duration/ID field, treated as an unsigned
-        // integer, are greater than 32 768, the contents are interpreted as appropriate
-        // for the frame type and subtype or ignored if the receiving MAC entity does
-        // not have a defined interpretation for that type and subtype (IEEE 802.11-2016
-        // sec. 10.27.3)
         return;
     }
 
@@ -1122,10 +1151,12 @@
         // (IEEE 802.11-2016 sec. 10.3.2.4)
         if (psdu->GetHeader(0).IsRts())
         {
+            WifiTxVector ctsTxVector =
+                GetWifiRemoteStationManager()->GetCtsTxVector(psdu->GetAddr2(), txVector.GetMode());
             Time navResetDelay =
                 2 * m_phy->GetSifs() +
-                WifiPhy::CalculateTxDuration(GetCtsSize(), txVector, m_phy->GetPhyBand()) +
-                m_phy->CalculatePhyPreambleAndHeaderDuration(txVector) + 2 * m_phy->GetSlot();
+                WifiPhy::CalculateTxDuration(GetCtsSize(), ctsTxVector, m_phy->GetPhyBand()) +
+                m_phy->CalculatePhyPreambleAndHeaderDuration(ctsTxVector) + 2 * m_phy->GetSlot();
             m_navResetEvent =
                 Simulator::Schedule(navResetDelay, &FrameExchangeManager::NavResetTimeout, this);
         }
@@ -1143,6 +1174,12 @@
     m_channelAccessManager->NotifyNavResetNow(Seconds(0));
 }
 
+bool
+FrameExchangeManager::VirtualCsMediumIdle() const
+{
+    return m_navEnd <= Simulator::Now();
+}
+
 void
 FrameExchangeManager::ReceiveMpdu(Ptr<const WifiMpdu> mpdu,
                                   RxSignalInfo rxSignalInfo,
@@ -1166,7 +1203,7 @@
             // - If the NAV indicates idle, the STA shall respond with a CTS frame after a SIFS
             // - Otherwise, the STA shall not respond with a CTS frame
             // (IEEE 802.11-2016 sec. 10.3.2.7)
-            if (m_navEnd <= Simulator::Now())
+            if (VirtualCsMediumIdle())
             {
                 NS_LOG_DEBUG("Received RTS from=" << hdr.GetAddr2() << ", schedule CTS");
                 Simulator::Schedule(m_phy->GetSifs(),
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/frame-exchange-manager.h ns-3.38/src/wifi/model/frame-exchange-manager.h
--- ns-3.37/src/wifi/model/frame-exchange-manager.h	2022-11-01 17:37:24.743395800 -0700
+++ ns-3.38/src/wifi/model/frame-exchange-manager.h	2023-03-16 20:54:23.856869200 -0700
@@ -101,7 +101,7 @@
      *
      * \param linkId the ID of the link this Frame Exchange Manager is associated with
      */
-    void SetLinkId(uint8_t linkId);
+    virtual void SetLinkId(uint8_t linkId);
     /**
      * Set the MAC layer to use.
      *
@@ -236,6 +236,11 @@
     virtual void CalculateAcknowledgmentTime(WifiAcknowledgment* acknowledgment) const;
 
     /**
+     * \return true if the virtual CS indication is that the medium is idle
+     */
+    virtual bool VirtualCsMediumIdle() const;
+
+    /**
      * Notify that an internal collision has occurred for the given Txop
      *
      * \param txop the Txop for which an internal collision has occurred
@@ -364,12 +369,12 @@
     virtual void RetransmitMpduAfterMissedAck(Ptr<WifiMpdu> mpdu) const;
 
     /**
-     * Make the sequence number of the given MPDU available again if the MPDU has
-     * never been transmitted.
+     * Make the sequence numbers of MPDUs included in the given PSDU available again
+     * if the MPDUs have never been transmitted.
      *
-     * \param mpdu the given MPDU
+     * \param psdu the given PSDU
      */
-    virtual void ReleaseSequenceNumber(Ptr<WifiMpdu> mpdu) const;
+    virtual void ReleaseSequenceNumbers(Ptr<const WifiPsdu> psdu) const;
 
     /**
      * Pass the given MPDU, discarded because of the max retry limit was reached,
@@ -382,7 +387,7 @@
     /**
      * Perform actions that are possibly needed when receiving any frame,
      * independently of whether the frame is addressed to this station
-     * (e.g., setting the NAV or the TXOP holder).
+     * (e.g., storing buffer status reports).
      *
      * \param psdu the received PSDU
      * \param txVector TX vector of the received PSDU
@@ -390,6 +395,16 @@
     virtual void PreProcessFrame(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector);
 
     /**
+     * Perform actions that are possibly needed after receiving any frame,
+     * independently of whether the frame is addressed to this station
+     * (e.g., setting the NAV or the TXOP holder).
+     *
+     * \param psdu the received PSDU
+     * \param txVector TX vector of the received PSDU
+     */
+    virtual void PostProcessFrame(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector);
+
+    /**
      * Get the updated TX duration of the frame associated with the given TX
      * parameters if the size of the PSDU addressed to the given receiver
      * becomes <i>ppduPayloadSize</i>.
@@ -581,6 +596,11 @@
      */
     void DoCtsTimeout(Ptr<WifiPsdu> psdu);
 
+    /**
+     * Reset this frame exchange manager.
+     */
+    virtual void Reset();
+
   private:
     /**
      * \param txVector the TXVECTOR decoded from PHY header.
@@ -599,11 +619,6 @@
      */
     void SendMpdu();
 
-    /**
-     * Reset this frame exchange manager.
-     */
-    virtual void Reset();
-
     Ptr<WifiMpdu> m_mpdu;           //!< the MPDU being transmitted
     WifiTxParameters m_txParams;    //!< the TX parameters for the current frame
     Ptr<Packet> m_fragmentedPacket; //!< the MSDU being fragmented
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/he/he-capabilities.cc ns-3.38/src/wifi/model/he/he-capabilities.cc
--- ns-3.37/src/wifi/model/he/he-capabilities.cc	2022-11-01 17:37:24.743395800 -0700
+++ ns-3.38/src/wifi/model/he/he-capabilities.cc	2023-03-16 20:54:23.856869200 -0700
@@ -152,7 +152,7 @@
 {
     // write the corresponding value for each bit
     start.WriteHtolsbU32(GetHeMacCapabilitiesInfo1());
-    start.WriteU16(GetHeMacCapabilitiesInfo2());
+    start.WriteHtolsbU16(GetHeMacCapabilitiesInfo2());
     start.WriteHtolsbU64(GetHePhyCapabilitiesInfo1());
     start.WriteHtolsbU16(GetHePhyCapabilitiesInfo2());
     start.WriteU8(GetHePhyCapabilitiesInfo3());
@@ -610,14 +610,14 @@
 }
 
 std::ostream&
-operator<<(std::ostream& os, const HeCapabilities& HeCapabilities)
+operator<<(std::ostream& os, const HeCapabilities& heCapabilities)
 {
-    os << HeCapabilities.GetHeMacCapabilitiesInfo1() << "|"
-       << +HeCapabilities.GetHeMacCapabilitiesInfo2() << "|"
-       << HeCapabilities.GetHePhyCapabilitiesInfo1() << "|"
-       << HeCapabilities.GetHePhyCapabilitiesInfo2() << "|"
-       << +HeCapabilities.GetHePhyCapabilitiesInfo3() << "|"
-       << HeCapabilities.GetSupportedMcsAndNss();
+    os << heCapabilities.GetHeMacCapabilitiesInfo1() << "|"
+       << +heCapabilities.GetHeMacCapabilitiesInfo2() << "|"
+       << heCapabilities.GetHePhyCapabilitiesInfo1() << "|"
+       << heCapabilities.GetHePhyCapabilitiesInfo2() << "|"
+       << +heCapabilities.GetHePhyCapabilitiesInfo3() << "|"
+       << heCapabilities.GetSupportedMcsAndNss();
     return os;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/he/he-capabilities.h ns-3.38/src/wifi/model/he/he-capabilities.h
--- ns-3.37/src/wifi/model/he/he-capabilities.h	2022-11-01 17:37:24.743395800 -0700
+++ ns-3.38/src/wifi/model/he/he-capabilities.h	2023-03-16 20:54:23.856869200 -0700
@@ -336,10 +336,10 @@
 /**
  * output stream output operator
  * \param os the output stream
- * \param HeCapabilities the HE capabilities
+ * \param heCapabilities the HE capabilities
  * \returns the output stream
  */
-std::ostream& operator<<(std::ostream& os, const HeCapabilities& HeCapabilities);
+std::ostream& operator<<(std::ostream& os, const HeCapabilities& heCapabilities);
 
 } // namespace ns3
 
